' Melt all the characters off of the screen.
' Original routine by Dave Navarro, Jr.
' Enhancements by Alan C. Earnshaw

DEFINT A-Z

' determine the number of characters on the screen (zero-based)
Cells% = pbvScrnRows * pbvScrnCols - 1
Range% = Cells%

IF BIT(pbvScrnCard, 1) THEN	' using a color adapter
  DIM DYNAMIC ScreenMem%(0:Cells%) AT &HB800
ELSE				' using a monochrome adapter
  DIM DYNAMIC ScreenMem%(0:Cells%) AT &HB000
END IF

DO
  Cells% = Range%		' restore value
  FOR c% = 0 TO Range%
    Cell% = ScreenMem%(c%)          ' get char & attribute from screen
    Char% = Cell% AND &HFF           ' isolate char
    IF Char% = 32 THEN            ' is it a space?
      Cell% = &H0720               ' yes, make sure it's white on black
      DECR Cells%                  ' one less non-space on screen
    ELSEIF Char% < 32 THEN        ' is it a control char?
      INCR Cell%                   ' add one to move it closer to a space
    ELSE                        ' it's above a space
      DECR Cell%                   ' so subtract one to move it close to a space
    END IF
    ScreenMem%(c%) = Cell%           ' put it back
  NEXT c%
LOOP WHILE Cells% >= 0                  ' keep looping until they're all spaces
